* Here is another recursive routine, this one adding or removing library
* modules from memory.  This one uses a recursive call only to save a few
* lines of code, and it is really more interesting academically to show
* beginners how and why use recursivity than to demonstrate a complicated
* problem solved with recursivity.

* Since FoxPro authors did not think of that one, and since it is
* one that I use quite frequently, I thought it may interest you all.

* CALL:         Result = libfunc (Action, Libfile)
* Where:        Result = Boolean (True/False) result of process
*               Action = "L" or "R"  ("L" to load, "R" to release)
*               Libfile = Name of library file to load or release

* Jose Dubois - 72110,3245




* Example showing how to use LIBFUNC

Lib_Ok = libfunc ("L", "plbs\phdbase")
? Lib_Ok
? SET("LIBRARY")
RETURN




* Function that handles the loading and releasing of libraries
* Using recursive calls to reload libraries individually
* Jose Dubois - 12/14/92

FUNCTION libfunc
PARAMETERS l_oper, l_lib

   PRIVATE l_Ok, l_libnam, l_libs, l_oper, l_lib, l_curlib, l_com

   l_libnam = defext(l_lib, "PLB")				&& Complete lib name
   DO CASE

      CASE l_oper = "L"						&& Add a module
         IF FILE(l_libnam)					&& Was lib found?
            SET LIBRARY TO &l_libnam ADDITIVE                   && Load the module
            l_Ok = l_libnam $ SET("LIBRARY")                    && Is is loaded?
         ELSE
            l_Ok = .F.                                          && No such file
         ENDIF

      CASE l_oper = "R"	    					&& Release a module
      
         IF l_libnam $ SET("LIBRARY")                           && Is module loaded?
         
            l_Ok = .T.						&& Default to success
            l_libs = SET("LIBRARY")				&& Get current lib list
            SET LIBRARY TO					&& Clear lib list

            l_libs = l_libs + ", "                              && Standardize lib list

            * Reload all except specified one (l_libnam)
            DO WHILE LEN(l_libs) > 2
            
               * Parse string
               l_com = AT(",", l_libs)
               l_curlib = LEFT(l_libs, l_com - 1)		&& Isolate 1 lib
               l_libs = STRTRAN (l_libs, LEFT(l_libs, ;
                        l_com + 1), "", 1, 1)                   && Remove from list

               IF !l_libnam $ l_curlib				&& If not to remove,
                                                                && then add it

                  l_Ok = libfunc ("L", l_curlib)                && Recursive call to add lib

                  IF !l_Ok                                      && Error loading!
                     ? "?Could not load library " + l_curlib
                  ENDIF
                  
               ENDIF

            ENDDO
            
         ELSE
            l_Ok = .F.                                          && Not in lib list

         ENDIF
         
      OTHERWISE
         l_Ok = .F.                                             && Not a valid action
   ENDCASE

   RETURN l_Ok
   
   
   

* Returns uppercased legal file name with default extension
* Jose Dubois - 12/14/92

FUNCTION defext
PARAMETERS d_name, d_ext
   IF AT(".", d_name) = 0 .OR. AT(".", d_name) = LEN(d_name)
      d_name = d_name + IIF(AT(".",d_name)=0,".","") + d_ext
   ENDIF
RETURN UPPER(d_name)

